<!DOCTYPE html>
<html>
  <head>
    <meta name="viewport" content="width=device-width,initial-scale=1.0">
    <title>Socket.IO chat</title>
    <style>
      body { margin: 0; padding-bottom: 3rem; font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Roboto, Helvetica, Arial, sans-serif; }

      #form { background: rgba(0, 0, 0, 0.15); padding: 0.25rem; position: fixed; bottom: 0; left: 0; right: 0; display: flex; height: 3rem; box-sizing: border-box; backdrop-filter: blur(10px); }
      #input { border: none; padding: 0 1rem; flex-grow: 1; border-radius: 2rem; margin: 0.25rem; }
      #input:focus { outline: none; }
      #form > button { background: #333; border: none; padding: 0 1rem; margin: 0.25rem; border-radius: 3px; outline: none; color: #fff; }

      #messages { list-style-type: none; margin: 0; padding: 0; }
      #messages > li { padding: 0.5rem 1rem; }
      #messages > li:nth-child(odd) { background: #efefef; }
    </style>
  </head>
  <body>
    <div>
      <p> <span id="username">No username</span> ~ <span>V.1</span> </p>
    </div>
    <ul id="messages"></ul>
    <form id="form" action="">
      <input id="input" autocomplete="off" /><button>Send</button>
      <button id="get-history-btn">More history</button>
      <button id="search-btn">Search</button>
    </form>

    <script src="/socket.io/socket.io.js"></script>

    <script>
      let counter = 0;
      let counterHistory = 0;

      // obtener el nombre de usuario del almacenamiento local
      let storedUsername = localStorage.getItem('username');

      if (!storedUsername) {
        storedUsername = prompt('What is your username?');
        if (!storedUsername) {
          location.reload();
        }
      }

      // guardar el nombre de usuario en el almacenamiento local
      localStorage.setItem('username', storedUsername);
      username.textContent = storedUsername;

      const socket = io.connect(window.location.origin, {
        ackTimeout: 10000,
        retries: 3,
        auth: {
          startOffset: 0,
          serverOffset: 0,
          username: storedUsername
        }
      });

      const form = document.getElementById('form');
      const input = document.getElementById('input');
      const messages = document.getElementById('messages');

      form.addEventListener('submit', (e) => {
        e.preventDefault();
        if (input.value) {
          const clientOffset = `${socket.id}-${counter++}`;
          socket.emit('chat message', input.value, clientOffset);
          input.value = '';
        }
      });

      socket.on('chat message', (msg, serverOffset, startOffset=-1) => {
        const item = document.createElement('li');
        item.textContent = msg;
        messages.appendChild(item);
        window.scrollTo(0, document.body.scrollHeight);
        socket.auth.serverOffset = serverOffset;

        if (startOffset !== -1) {
          socket.auth.startOffset = startOffset;
        }
      });

      socket.on('chat message error', (msg) => {
        const item = document.createElement('li');
        item.textContent = msg;
        messages.appendChild(item);
        window.scrollTo(0, document.body.scrollHeight);
      });

      socket.on('chat message history', (msg, newStartOffset) => {
        // agregar al inicio de la lista
        const item = document.createElement('li');
        item.textContent = msg;
        messages.insertBefore(item, messages.firstChild);
        socket.auth.startOffset = newStartOffset;
      });
    </script>

    <script>
      const getHistoryButton = document.getElementById('get-history-btn');

      getHistoryButton.addEventListener('click', (e) => {
        e.preventDefault();

        fetch(`/history?startOffset=${socket.auth.startOffset}&username=${socket.auth.username}`)
          .then((response) => response.json())
          .then((data) => {
            /*data.forEach((msg) => {
              const item = document.createElement('li');
              item.textContent = msg;
              messages.appendChild(item);
            });
            window.scrollTo(0, document.body.scrollHeight);*/
            console.log(data);
          });
      });
    </script>

    <script>
      const searchButton = document.getElementById('search-btn');

      searchButton.addEventListener('click', (e) => {
        e.preventDefault();
        if (input.value) {
          fetch(`/search?content=${input.value}&username=${socket.auth.username}&startOffset=${socket.auth.startOffset}`)
          .then((response) => response.json())
          .then((data) => {
            /*data.forEach((msg) => {
              const item = document.createElement('li');
              item.textContent = msg;
              messages.appendChild(item);
            });
            window.scrollTo(0, document.body.scrollHeight);*/
            console.log(data);
          });
          input.value = '';
        }
      });
    </script>
  </body>
</html>